pidgin: imgstore.h File Reference

pidgin 2.14.4

Loading...
Searching...
No Matches
Typedefs | Functions
imgstore.h File Reference
libpurple

IM Image Store API. More...

`#include <glib.h>`

Go to the source code of this file.

## Typedefs
typedef struct _PurpleStoredImage | PurpleStoredImage
| A set of utility functions that provide a reference-counted immutable wrapper around an image's data and filename.

## Functions
PurpleStoredImage * | purple_imgstore_add (gpointer data, size_t size, const char *filename)
| Create a new PurpleStoredImage.
PurpleStoredImage * | purple_imgstore_new_from_file (const char *path)
| Create a PurpleStoredImage using purple_imgstore_add() by reading the given filename from disk.
int | purple_imgstore_add_with_id (gpointer data, size_t size, const char *filename)
| Create a PurpleStoredImage using purple_imgstore_add() and add the image to the image store.
PurpleStoredImage * | purple_imgstore_find_by_id (int id)
| Retrieve an image from the store.
gconstpointer | purple_imgstore_get_data (PurpleStoredImage *img)
| Retrieves a pointer to the image's data.
size_t | purple_imgstore_get_size (PurpleStoredImage *img)
| Retrieves the length of the image's data.
const char * | purple_imgstore_get_filename (const PurpleStoredImage *img)
| Retrieves a pointer to the image's filename.
const char * | purple_imgstore_get_extension (PurpleStoredImage *img)
| Looks at the magic numbers of the image data (the first few bytes) and returns an extension corresponding to the image's file type.
PurpleStoredImage * | purple_imgstore_ref (PurpleStoredImage *img)
| Increment the reference count.
PurpleStoredImage * | purple_imgstore_unref (PurpleStoredImage *img)
| Decrement the reference count.
void | purple_imgstore_ref_by_id (int id)
| Increment the reference count using an ID.
void | purple_imgstore_unref_by_id (int id)
| Decrement the reference count using an ID.
void * | purple_imgstore_get_handle (void)
| Returns the image store subsystem handle.
void | purple_imgstore_init (void)
| Initializes the image store subsystem.
void | purple_imgstore_uninit (void)
| Uninitializes the image store subsystem.

## Detailed Description

IM Image Store API.

See also
  Image Store Signals

Definition in file imgstore.h.

## Typedef Documentation

## ◆ PurpleStoredImage

typedef struct _PurpleStoredImage PurpleStoredImage

A set of utility functions that provide a reference-counted immutable wrapper around an image's data and filename.

These functions do not cache any data to disk.

Definition at line 37 of file imgstore.h.

## Function Documentation

## ◆ purple_imgstore_add()

PurpleStoredImage * purple_imgstore_add | ( | gpointer | data,
|  | size_t | size,
|  | const char * | filename
| ) |  |

Create a new PurpleStoredImage.

Despite the name of this function, the image is NOT added to the image store and no ID is assigned. If you need to reference the image by an ID, use purple_imgstore_add_with_id() instead.

The caller owns a reference to this image and must dereference it with purple_imgstore_unref() for it to be freed.

Parameters

  data | Pointer to the image data, which the imgstore will take ownership of and free as appropriate. If you want a copy of the data, make it before calling this function.
  size | Image data's size.
  filename | Filename associated with image. This is for your convenience. It could be the full path to the image or, more commonly, the filename of the image without any directory information. It can also be NULL, if you don't need to keep track of a filename.

Returns
  The stored image, or NULL if the image was not added (because of empty data or size).

## ◆ purple_imgstore_add_with_id()

int purple_imgstore_add_with_id | ( | gpointer | data,
|  | size_t | size,
|  | const char * | filename
| ) |  |

Create a PurpleStoredImage using purple_imgstore_add() and add the image to the image store.

A unique ID will be assigned to the image.

The caller owns a reference to the image and must dereference it with purple_imgstore_unref() or purple_imgstore_unref_by_id() for it to be freed.

Parameters

  data | Pointer to the image data, which the imgstore will take ownership of and free as appropriate. If you want a copy of the data, make it before calling this function.
  size | Image data's size.
  filename | Filename associated with image. This is for your convenience. It could be the full path to the image or, more commonly, the filename of the image without any directory information. It can also be NULL, if you don't need to keep track of a filename.

Returns
  ID for the image. This is a unique number that can be used within libpurple to reference the image. 0 is returned if the image was not added (because of empty data or size).

## ◆ purple_imgstore_find_by_id()

PurpleStoredImage * purple_imgstore_find_by_id | ( | int | id | ) |

Retrieve an image from the store.

The caller does not own a reference to the image.

Parameters

  id | The ID for the image.

Returns
  A pointer to the requested image, or NULL if it was not found.

## ◆ purple_imgstore_get_data()

gconstpointer purple_imgstore_get_data | ( | PurpleStoredImage * | img | ) |

Retrieves a pointer to the image's data.

Parameters

  img | The Image.

Returns
  A pointer to the data, which must not be freed or modified.

## ◆ purple_imgstore_get_extension()

const char * purple_imgstore_get_extension | ( | PurpleStoredImage * | img | ) |

Looks at the magic numbers of the image data (the first few bytes) and returns an extension corresponding to the image's file type.

Parameters

  img | The image.

Returns
  The image's extension (for example "png") or "icon" if unknown.

## ◆ purple_imgstore_get_filename()

const char * purple_imgstore_get_filename | ( | const PurpleStoredImage * | img | ) |

Retrieves a pointer to the image's filename.

Parameters

  img | The image.

Returns
  A pointer to the filename, which must not be freed or modified.

## ◆ purple_imgstore_get_handle()

void * purple_imgstore_get_handle | ( | void |  | ) |

Returns the image store subsystem handle.

Returns
  The subsystem handle.

## ◆ purple_imgstore_get_size()

size_t purple_imgstore_get_size | ( | PurpleStoredImage * | img | ) |

Retrieves the length of the image's data.

Parameters

  img | The Image.

Returns
  The size of the data that the pointer returned by purple_imgstore_get_data points to.

## ◆ purple_imgstore_new_from_file()

PurpleStoredImage * purple_imgstore_new_from_file | ( | const char * | path | ) |

Create a PurpleStoredImage using purple_imgstore_add() by reading the given filename from disk.

The image is not added to the image store and no ID is assigned. If you need to reference the image by an ID, use purple_imgstore_add_with_id() instead.

The caller owns a reference to this image and must dereference it with purple_imgstore_unref() for it to be freed.

Parameters

  path | The path to the image.

Returns
  The stored image, or NULL if the image was not added (because of empty data or size).

Since
  2.5.0

## ◆ purple_imgstore_ref()

PurpleStoredImage * purple_imgstore_ref | ( | PurpleStoredImage * | img | ) |

Increment the reference count.

Parameters

  img | The image.

Returns
  img

## ◆ purple_imgstore_ref_by_id()

void purple_imgstore_ref_by_id | ( | int | id | ) |

Increment the reference count using an ID.

This is a convience wrapper for purple_imgstore_find_by_id() and purple_imgstore_ref(), so if you have a PurpleStoredImage, it'll be more efficient to call purple_imgstore_ref() directly.

Parameters

  id | The ID for the image.

## ◆ purple_imgstore_unref()

PurpleStoredImage * purple_imgstore_unref | ( | PurpleStoredImage * | img | ) |

Decrement the reference count.

If the reference count reaches zero, the image will be freed.

Parameters

  img | The image.

Returns
  img or `NULL` if the reference count reached zero.

## ◆ purple_imgstore_unref_by_id()

void purple_imgstore_unref_by_id | ( | int | id | ) |

Decrement the reference count using an ID.

This is a convience wrapper for purple_imgstore_find_by_id() and purple_imgstore_unref(), so if you have a PurpleStoredImage, it'll be more efficient to call purple_imgstore_unref() directly.

Parameters

  id | The ID for the image.